--
-- Cvicenie 6
-- Priklad 2
--
-- Autor: Ladislav Vastag III.rocnik SPZ
--
-- Rozsirte abstraktny typ Eq a Ord tak, aby bolo mozn pouzit ope-
-- racie porovnania (==), (/=), (<=), (>=), (<) a (>) na hodnotach
-- algebraickeho typu
--
--       data Colour = Red | Green | Blue
--
-- pricom je zname, ze v typovej triede Eq je definovan opercia (/=)
-- pomocou (==) a v typovej triede Ord su definovan opercie (>=), (<)
-- a (>) na zklade (<=).
-- Algebraicka specifikacia je nasledovna: Nech farby c1 a c2 s z mno-
-- ziny {Red, Green, Blue}. Ak s c1 a c2 rovnak, potom plat c1 = c2, v
-- opanom prpade c1 /= c2. Dalej pre hodnoty mnoziny {Red, Green, Blue}
-- plati usporiadanie: Red < Green < Blue.
-- Potom definujte mnozinovu abstrakciu pre generovanie zoznamu vset-
-- ych takych dvojic (x, y) farieb x a y, pre ktore plati x < y.
--

data Colour = Red | Green | Blue deriving (Show)

instance Eq (Colour) where
    (==) Red Red   = True
    (==) Red Green = False
    (==) Red Blue  = False

    (==) Green Red   = False
    (==) Green Green = True
    (==) Green Blue  = False

    (==) Blue Red   = False
    (==) Blue Green = False
    (==) Blue Blue  = True
    
instance Ord (Colour) where
-- Operacie (>=), (<) a (>) nie je nutne definovat, lebo tieto su definovane
-- na zaklade operacie (<=).
    (<=) Red Red   = True
    (<=) Red Green = True
    (<=) Red Blue  = True

    (<=) Green Red   = False
    (<=) Green Green = True
    (<=) Green Blue  = True

    (<=) Blue Red   = False
    (<=) Blue Green = False
    (<=) Blue Blue  = True


colours = [(x,y) | x<-[Red,Green,Blue], y<-[Red,Green,Blue], x<y]