--
-- Niekolko aplikacii triediacich algoritmov
--
-- Autor: Ladislav Vastag III.rocnik SPZ
--

------------------------------- Quick Sort ---------------------------------
-- qsort :: [a] -> [a]
qsort [] = []
qsort (x:xs) = qsort [u | u<-xs,u<=x] ++[x]++ qsort [v | v<-xs,v>x]


------------------- Triedenie rozdelovanim a spojovanim -----------------------
-- msort :: [a] -> [a]
msort xs | (length xs)<=1 = xs
         | otherwise = merge (msort us) (msort vs)
         where us = take (div n 2) xs
               vs = drop (div n 2) xs
               
-- merge :: [a]->[a]->[a]
merge [] ys = ys
merge (x:xs) [] = x:xs
merge (x:xs) (y:ys) | x<=y = x:(merge xs (y:ys))
                    | otherwise = y:(merge (x:xs) ys)

                    
-------------------- Insert Sort - triedenie vkladanim ------------------------
isort xs = foldr insert [] xs
           where insert x [] = [x]
                 insert x (y:ys) | x<=y = x:(y:ys)
                                 | otherwise = y:insert x ys