--
-- Cvicenie 3
-- Priklad 8
--
-- Autor: Ladislav Vastag III.rocnik SPZ
--
-- Definujte funkciu charCounts, ktorej argumentom je retazec znakov a
-- hodnotou dvojica, ktorej prvym prvkom je znak a druhym cislo, urcu-
-- juce pocet opakovani tohto znaku v postupnosti. Napr. pre "abbabbb"
-- da hodnotu [('a', 1), ('b', 2), ('a', 1), ('b', 3)] (Navod: Definujte najprv
-- funkciu pre rozklad retazca do zoznamu retazcov s postupnostami
-- rovnakych znakov. Pritom pouzite funkciu takeWhile a dropWhile. Vy-
-- sledok by mal byt v tvare ["a", "bb", "a", "bbb"]. Potom (t.j. pouzite
-- kompoziciu) mapovanim tohto vysledku funkciou, ktor zisti znak a
-- pocet jeho vyskytov v retazci definujte funkciu charCounts.
-- 

charCounts :: String -> [(Char,Int)]
charCounts xs = map pocetZnakov (zoznam xs)
      where 
            zoznam :: String -> [String]
            zoznam [] = []
            zoznam (x:xs) = [takeWhile (x==) (x:xs)] ++ zoznam (dropWhile (x==)(x:xs))

            pocetZnakov :: String -> (Char,Int)
            pocetZnakov (x:xs) = (x,length (x:xs))